using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BeyondBasicUnitTesting.Business
{
    public class PersonFacade2 : IPersonFacade
    {
        public PersonFacade2(ILogger logger)
        {
            if (logger == null)
            {
                throw new ArgumentNullException("logger", "Argument cannot be null.");
            }

            m_loggerInstance = logger;
        }

        private ILogger m_loggerInstance;
        public ILogger LoggerInstance
        {
            get { return m_loggerInstance; }
        }

        public bool IsPersonValid(IPerson checkThis)
        {
            if (checkThis == null)
            {
                return false;
            }
            else
            {
                if (checkThis.FirstName == null || checkThis.LastName == null || checkThis.EmailAddress == null || checkThis.Status == null)
                {
                    return false;
                }
                else
                {
                    return true;
                }
            }
        }

        public void SavePerson(IPerson saveThis)
        {
            try
            {
                SavePersonData(saveThis.FirstName, saveThis.LastName, saveThis.EmailAddress, saveThis.Status);
                saveThis.Id = new Random().Next(1, Int32.MaxValue);
            }
            catch (Exception ex)
            {
                //new Logger().WriteToLog(ex.ToString());
                LoggerInstance.WriteToLog(ex.ToString());
                throw;
            }
        }

        private void SavePersonData(string firstName, string lastName, string emailAddress, string status)
        {
            Console.WriteLine(String.Format("SavePerson(): {0} {1} {2} {3}", firstName, lastName, emailAddress, status));
        }
    }
}
