﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using BeyondBasicUnitTesting.Business;

namespace BeyondBasicUnitTesting.WinUI.Before
{
    public partial class PersonSearch : Form
    {
        public PersonSearch()
        {
            InitializeComponent();
        }

        private void m_btnCreateNew_Click(object sender, EventArgs e)
        {
            ShowDetails(-1);
        }

        private void m_btnRefresh_Click(object sender, EventArgs e)
        {
            RefreshGrid();
        }

        private void RefreshGrid()
        {
            IPersonFacade facade = new PersonFacade(
                            DemoSession.GetCurrent().LoggerInstance,
                            DemoSession.GetCurrent().PersonRepositoryInstance);

            IList<IPerson> results = facade.GetAll();

            m_grid.DataSource = null;
            m_grid.DataSource = results;            
        }

        private void PersonSearch_Load(object sender, EventArgs e)
        {
            RefreshGrid();
        }

        private void m_grid_RowHeaderMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            try
            {
                var index = e.RowIndex;

                IPersonFacade facade = new PersonFacade(
                            DemoSession.GetCurrent().LoggerInstance,
                            DemoSession.GetCurrent().PersonRepositoryInstance);

                IList<IPerson> results = facade.GetAll();

                var item = results[index];

                ShowDetails(item.Id);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            } 
        }

        private void ShowDetails(int personId)
        {
            PersonDetail editor = new PersonDetail();

            editor.Initialize(personId);

            editor.Show();
        }
    }
}
